# -*- coding: latin1 -*-
"""
Esporta in Excel il risultato di una Query SQL

Richiede il componente PythonWin

"""

import win32com.client
import ExcelXML

# Cambiare il database (in questo caso Access) e la Select da eseguire
DSN = 'PROVIDER=Microsoft.Jet.OLEDB.4.0;DATA SOURCE=D:/EuroLab/Eurolab.mdb;'
sSQL = 'SELECT * FROM dClienti'

# Si conette al DB
conn = win32com.client.Dispatch(r'ADODB.Connection')
conn.Open(DSN)

# stampa l'elenco tabelle e viste dal DB
#adSchemaTables = 20
#rsTables = conn.OpenSchema(adSchemaTables)
#rsTables.Filter = "TABLE_TYPE = 'TABLE'"    # 'VIEW'"
# si scorre tutto il recordset filtrato
#while not rsTables.EOF:
#    v = rsTables.Fields.Item(2).Value
#    print v
#    rsTables.MoveNext()

# Crea il Recordset eseguendo la Select
rs = win32com.client.Dispatch(r'ADODB.Recordset')
rs_SQL = sSQL
rs.Open(rs_SQL, conn, 1, 3) # 1 e 3 sono constanti:  adOpenKeyset e adLockOptimistic
# Recupera i nomi dei campi
flds = []
for x in range(rs.Fields.Count):
    flds.append(rs.Fields.Item(x).Name)
nFields = rs.Fields.Count

# inizializza Excel
x1 = ExcelXML.xlsExcel("ExportSQL1.xml")
Sh = ExcelXML.xlsSheetStruct()
Sh.Description = "Esportazione di: " + sSQL

# aggiunge uno stile per l'intestazione campi
st = ExcelXML.xlsStyleStruct()
st.ID = "bold"
#st.FontName = "Arial"
st.FontBold  = True
st.FontItalic  = True
x1.xlsAddStyle(st)

x1.xlsAddSheet("Query", Sh)
x1.xlsWriteCell("Esportazione di: " + sSQL)
x1.xlsNewLine(1)
# scrive l'intestazione dei campi
x1.xlsWriteCell(flds,"S","bold")
x1.xlsNewLine()

rs.MoveFirst()
count = 0
# si scorre tutto il recordset
while not rs.EOF:
    for n in range(nFields):  # si scorre tutti i campi della riga
        v = rs.Fields.Item(n).Value
        if type(v).__name__ == 'unicode':  v = v.encode('dbcs')  # evita problemi con caratteri strani
        if type(v).__name__ == 'int':
           x1.xlsWriteCell(v, "N")
        else:
           x1.xlsWriteCell(v)
    x1.xlsNewLine()

    count = count + 1
    rs.MoveNext()

x1.xlsClose()

print "E' stato generato il file 'ExportSQL1.xml'"

